#!/usr/bin/env/ python

'''
ROT13 is a way to encode secret messages in cryptography. 
The name comes from Julius Caesar, who used it to communicate with his generals. 
ROT13 ("rotate by 13 places") is a widely used example of a Caesar cipher. 
The idea is to rotate or augment the position of each character in the alphabet with thirteen places. 
Your task in this exercise is to implement an encoder/decoder of ROT-13. 
For this, you will need to create a list containing each letter in the (lowercase) roman alphabet 
as well as the whitespace character. 
Next, you will have to create an encode_dict and a decode_dict. 
Once you're done, you will be able to read the following secret message: 
"Pnrfne pvcure? V zhpu cersre Pnrfne fnynq!" (Hint: you can use .index() 
to retrieve the position of an item in a list!)
'''

# alphabet = ("a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", " ", ".", ",", "?", "!")
# punct = [" ", ".", ",", "?", "!"]
# encode_dict = {}
# decode_dict = {}

# # create encoding dictionary
# for letter in alphabet:
# 	ROT13 = 0
# 	pos = alphabet.index(letter)
# 	print("pos letter:" + str(pos))
# 	if letter in punct:
# 		ROT13 = pos
# 	elif pos >= 14:
# 		ROT13 = 13-(26 - pos)
# 	else:
# 		ROT13 = pos + 13
# 	print("pos ROT13:" + str(ROT13))
# 	encode_dict[letter] = alphabet[ROT13]

# print("encode dict:") 
# print(encode_dict)

# # create decoding dictionary by inversing keys/values
# for key, value in zip(encode_dict.keys(), encode_dict.values()):
#     decode_dict[value] = key
# print("decode dict:")
# print(decode_dict)

# # decode sentence
# encoded = "Pnrfne pvcure? V zhpu cersre Pnrfne fnynq!"
# encoded = encoded.lower()
# decode = []
# words = list(encoded)
# for letter in words:
# 	if letter in decode_dict:
# 		decoded_letter = decode_dict[letter]
# 		decode.append(decoded_letter)

# print("".join(decode))

# result: caesar cipher? i much prefer caesar salad!


## OF
alphabet = list("abcdefghijklmnopqrstuvwxyz")

encode_dict = {}
for letter in alphabet:
	key_letter_rot = alphabet.index(letter)+13
	if key_letter_rot < 26:
		encode_dict[letter] = alphabet[key_letter_rot]
	else: 
		key_letter_rot = key_letter_rot-26
		encode_dict[letter] = alphabet[key_letter_rot]
print(encode_dict)


decode_dict = {}
for letter in alphabet:
	letter_key = alphabet.index(letter)-13
	if letter_key < 0:
		letter_key_rot = 26 + letter_key
		decode_dict[letter] = alphabet[letter_key_rot]
	else:
		decode_dict[letter] = alphabet[letter_key]
print(decode_dict)

#decode sentence
s = "Pnrfne pvcure? V zhpu cersre Pnrfne fnynq!"
s = s.lower()
decoded = []
words = list(s)
for letter in words:
	if letter =="?" or letter == "!" or letter == " ":
		decoded.append(letter)
	else: 
		decoded.append(decode_dict[letter])

print(''.join(decoded))

coded = []
for letter in decoded:
	if letter =="?" or letter == "!" or letter == " ":
		decoded.append(letter)
	else: 
		decoded.append(decode_dict[letter])
